/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// A U T O S Y M B - a tool for db92                                       //
// automatically generates a symbolic information file                     //
// that you include in your program file                                   //
// (c) Tleilax 08/1997                                                     //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <string.h>


int main ( int argc, char *argv[] )
{
  FILE *f1, *f2;
  char dummy[512], dummy2[512];
  char *c,*s1,*s2;

  printf ( "Automatic symbolic table builder for db92.\n(c) Tleilax 08/1997.\n\r" );
  if (argc<2)
  {
     printf ( "You must specify a file\n\r" );
     return 1;
  }

  strcpy ( dummy, argv[1] );
  f1 = fopen ( dummy, "rt" );
  if (!f1)
  {
     printf ( "File %s not found\n\r", dummy );
     return 1;
  }

  printf ( "Processing file %s. ", dummy );

  c=strchr ( dummy, '.' );
  if (!c) c=strchr ( dummy, 0 );
  strcpy ( c, ".sdb" );
  f2 = fopen ( dummy, "wt" );

  printf ( "Output file is %s.\n\rInclude it just before your program's entry point.", dummy );

  fputs ( ";db92 symbolic informations\n",f2 );
  fputs ( ";include JUST BEFORE your program's entry point\n;\n",f2 );
  fputs ( ";File built by AUTOSYMB\n\n\n",f2 );
  fputs ( "        include symb.inc\n\n", f2 );
  fputs ( "       dbl_begin\n", f2 );

  //Recherche des labels
  do
  {
    c=fgets ( dummy, 512, f1 );
    if (!c) break;
    s1=strtok ( c, " \t\n" );
    s2=strtok ( NULL, " \t\n" );
    if (s1[0]==';') continue;
    if (s1[strlen(s1)-1]==':')
    {
      if (s2) if (!strnicmp ( s2, "dc.", 3 )) continue;  // pas un vrai label
      s1[strlen(s1)-1]='\0';
      strcpy ( dummy2, "        dbl_add " );
      strcat ( dummy2, s1 );
      strcat ( dummy2, "\n" );
      fputs ( dummy2, f2 );
      continue;
    }
  } while (1);
  fputs ( "       dbl_end\n\n", f2 );

  rewind ( f1 );

  fputs ( "       dbv_begin\n", f2 );
  //Recherche des variables
  do
  {
    c=fgets ( dummy, 512, f1 );
    if (!c) break;
    s1=strtok ( c, " \t\n" );
    if (s1[0]==';') continue;
    s2=strtok ( NULL, " \t\n" );
    if (s2) if (!strnicmp ( s2, "dc.", 3 ))
    {
      if (s1[strlen(s1)-1]==':') s1[strlen(s1)-1]='\0';
      strcpy ( dummy2, "        dbv_add " );
      strcat ( dummy2, s1 );
      strcat ( dummy2, "," );
      switch ( s2[3] )
      {
        case 'b' :
        case 'B' : strcat ( dummy2, "dbv_BYTE" );break;
        case 'w' :
        case 'W' : strcat ( dummy2, "dbv_WORD" );break;
        case 'l' :
        case 'L' : strcat ( dummy2, "dbv_LONG" );break;
        default : continue;
      }
      strcat ( dummy2, "\n" );
      fputs ( dummy2, f2 );

      continue;
    }


  } while (1);
  fputs ( "       dbv_end\n\n", f2 );


  fputs ( "        db92_symbols\n", f2 );

  fclose ( f1 );
  fclose ( f2 );

  return 0;
}