dbv_BYTE          EQU     0
dbv_WORD          EQU     1
dbv_LONG          EQU     2


;begins the labels list
dbl_begin       MACRO
       _db_labels:
                ENDM
;ends the labels list
dbl_end         MACRO
        dc.w    0
                ENDM

;adds a label
;syntax:
;       dbl_add label_name
dbl_add         MACRO
        dc.w    \1-*
        dc.w    __dbl_\1-*
        dc.b    "\1"
        EVEN
       __dbl_\1:
                ENDM
        

;begins the variables list
dbv_begin       MACRO
       _db_variables:
                ENDM

;ends the variables list
dbv_end         MACRO
        dc.w    0
                ENDM

;adds a variable
;syntax:
;       dbv_add var_name,size
dbv_add         MACRO
        dc.w    \1-*
        dc.w    __dbv_\1-*
        dc.b    \2
        dc.b    "\1"
        EVEN
       __dbv_\1:
                ENDM


;declares debug informations
;it *MUST* be just before the program's entry point
db92_symbols    MACRO
        dc.w    _db_variables-*
        dc.w    _db_labels-*

        dc.b    "dinf"
                ENDM

;example :
;
;       @program        prog_code,prog_name
;
;       (...)
;Label1:
;       (...)
;
;       dbl_begin
;        dbl_add prog_code
;        dbl_add Label1
;        dbl_add Label2
;       dbl_end
;
;       dbv_begin
;        dbv_add Var1,dbv_BYTE
;        dbv_add Var2,dbv_WORD
;        dbv_add Var3,dbv_LONG
;       dbv_end
;
;       db92_symbols
;prog_code:
;       (...)
;       rts
;
;Label2:
;       (...)
;prog_name      dc.b    "dummy",0
;
;Var1           dc.b    0
;Var2           dc.w    0
;Var3           dc.l    0
;       (...)

